decidim-admin/config/routes.rb
# frozen_string_literal: true

Decidim::Admin::Engine.routes.draw do
  constraints(->(request) { Decidim::Admin::OrganizationDashboardConstraint.new(request).matches? }) do
    resource :organization, only: [:edit, :update], controller: "organization" do
      resource :appearance, only: [:edit, :update], controller: "organization_appearance"
      resource :homepage, only: [:edit, :update], controller: "organization_homepage" do
        resources :content_blocks, only: [:edit, :update, :destroy, :create], controller: "organization_homepage_content_blocks"
      end
      resource :external_domain_allowlist, only: [:edit, :update], controller: "organization_external_domain_allowlist"

      member do
        get :users
      end
    end

    resources :static_pages do
      put :update_content_blocks, on: :member
      resources :content_blocks, only: [:edit, :update, :destroy, :create], controller: "static_page_content_blocks"
    end
    resources :static_page_topics
    resources :scope_types, except: [:show]
    resources :scopes, except: [:show] do
      resources :scopes, except: [:show]
    end
    resources :metrics, only: [:index]
    resources :logs, only: [:index]
    resources :area_types, except: [:show]
    resources :areas, except: [:show]

    resources :authorization_workflows, only: :index

    resources :users, except: [:edit, :update], controller: "users" do
      member do
        post :resend_invitation, to: "users#resend_invitation"
      end
    end

    resources :officializations, only: [:new, :create, :index, :destroy], param: :user_id do
      member do
        get :show_email
      end
    end

    resources :moderated_users, only: [:index] do
      member do
        put :ignore
      end
      collection do
        scope "/:user_id" do
          resource :user_block, only: [:new, :create, :destroy], controller: :block_user
        end
        post :bulk_new, controller: :block_user
        post :bulk_create, controller: :block_user
        delete :bulk_destroy, controller: :block_user
        patch :bulk_unreport, controller: :moderated_users
      end
    end

    resources :impersonatable_users, only: [:index] do
      resources :promotions, controller: "managed_users/promotions", only: [:new, :create]
      resources :impersonation_logs, controller: "managed_users/impersonation_logs", only: [:index]
      resources :impersonations, controller: "impersonations", only: [:new, :create] do
        collection do
          post :close_session
        end
      end
    end

    resources :newsletter_templates, only: [:index, :show] do
      resources :newsletters, only: [:new, :create]

      member do
        get :preview
      end
    end

    resources :newsletters, except: [:new, :create] do
      member do
        post :recipients_count
        post :send_to_user
        get :preview
        get :select_recipients_to_deliver
        post :deliver
        get :confirm_recipients
      end
    end

    resource :help_sections, only: [:show, :update]

    namespace :admin_terms do
      get :show
      put :accept
    end

    resources :moderations, controller: "global_moderations" do
      member do
        put :unreport
        put :hide
        put :unhide
      end
      patch :bulk_action, on: :collection
      resources :reports, controller: "global_moderations/reports", only: [:index, :show]
    end

    resources :conflicts, only: [:index, :edit, :update], controller: "conflicts"

    resources :taxonomies, except: [:show] do
      patch :reorder, on: :collection
      resources :items, only: [:new, :create, :edit, :update], controller: "taxonomy_items"
      resources :filters, except: [:show], controller: "taxonomy_filters"
    end
    resources :taxonomy_filters_selector, param: :taxonomy_filter_id, except: [:edit, :update]

    root to: "dashboard#show"
  end
end

decidim-admin/app/controllers/decidim/admin/organization_external_domain_allowlist_controller.rb
# frozen_string_literal: true

module Decidim
  module Admin
    class OrganizationExternalDomainAllowlistController < Decidim::Admin::ApplicationController
      layout "decidim/admin/settings"

      add_breadcrumb_item_from_menu :admin_settings_menu

      helper_method :blank_external_domain

      def edit
        enforce_permission_to :update, :organization, organization: current_organization
        @form = form(OrganizationExternalDomainAllowlistForm).from_model(current_organization)
      end

      def update
        enforce_permission_to :update, :organization, organization: current_organization
        @form = form(OrganizationExternalDomainAllowlistForm).from_params(params)

        UpdateExternalDomainAllowlist.call(@form, current_organization) do
          on(:ok) do
            flash[:notice] = t("domain_allowlist.update.success", scope: "decidim.admin")
            redirect_to edit_organization_external_domain_allowlist_path
          end
          on(:invalid) do
            flash[:notice] = t("domain_allowlist.update.error", scope: "decidim.admin")
            render action: "edit"
          end
        end
      end

      private

      def blank_external_domain
        @blank_external_domain ||= Admin::ExternalDomainForm.new
      end
    end
  end
end

decidim-admin/app/views/decidim/admin/organization_external_domain_allowlist/_external_domain.html.erb
<div class="card external-domain mb-4" id="<%= id %>-field">
  <div class="card-divider external-domain-divider">
    <h2 class="card-title flex items-center">
      <span class="flex items-center gap-x-2"><%== icon("drag-move-2-fill") %></span>
      <span><%= t(".external_domain") %></span>

      <div class="flex items-center ml-auto gap-x-4">
        <button class="button button__sm button__transparent-secondary small alert move-up-question button--title">
          <%== "#{icon("arrow-up-line")} #{t(".up")}" %>
        </button>

        <button class="button button__sm button__transparent-secondary small alert move-down-question button--title">
          <%== "#{icon("arrow-down-line")} #{t(".down")}" %>
        </button>

        <button class="button button__sm button__transparent-secondary small alert remove-external-domain button--title">
          <%= icon("delete-bin-line") %>
          <%= t(".remove") %>
        </button>
      </div>
    </h2>
  </div>

  <div class="card-section">
    <div class="grid-x">
      <div class="cell">
        <div class="row column">
          <%= form.text_field :value %>
        </div>
      </div>
    </div>
    <%= form.hidden_field :id %>
    <%= form.hidden_field :position, value: form.object.position || 0 %>
    <%= form.hidden_field :deleted %>
  </div>
</div>

decidim-admin/app/views/decidim/admin/organization_external_domain_allowlist/_form.html.erb
<div class="form__wrapper">
  <div class="card">
    <div class="card-section">
      <% if form.send(:error?, :external_domains) %>
        <div>
          <div>&nbsp;</div>
          <%= form.send(:error_and_help_text, :external_domains) %>
        </div>
      <% end %>

      <div class="external-domains">
        <%= fields_for "external_domains[#{blank_external_domain.to_param}]", blank_external_domain do |external_domain_form| %>
          <script type="text/template" class="decidim-template">
            <%= render "external_domain",
                       form: external_domain_form,
                       id: blank_external_domain.to_param %>
          </script>
        <% end %>

        <div class="external-domains-list">
          <% @form.external_domains.each do |external_domain| %>
            <%= fields_for "external_domains[]", external_domain do |external_domain_form| %>
              <%= render "external_domain",
                         form: external_domain_form,
                         id: external_domain.to_param %>
            <% end %>
          <% end %>
        </div>
        <div class="row column">
          <button class="button button__sm button__secondary small add-external-domain"><%= t(".add") %></button>
        </div>
      </div>
    </div>
  </div>
</div>

decidim-admin/app/views/decidim/admin/organization_external_domain_allowlist/edit.html.erb
<% add_decidim_page_title(t("edit_external_domains", scope: "decidim.admin.titles")) %>

<div class="item_show__header">
  <h1 class="item_show__header-title">
    <%= t("title", scope: "decidim.admin.organization_external_domain_allowlist.form") %>
  </h1>
</div>

<div class="item__edit-form">
  <%= decidim_form_for(@form, html: { class: "form-defaults form edit_organization_external_domain_allowlist" }, url: organization_external_domain_allowlist_path, method: :patch) do |f| %>
    <%= render partial: "form", object: f %>
    <div class="item__edit-sticky">
      <div class="item__edit-sticky-container">
        <%= f.submit t(".update"), class: "button button__sm button__secondary" %>
      </div>
    </div>
  <% end %>
</div>